Index: azure_iot_hub/trunk/asp3_dcre/sample/Makefile
===================================================================
--- azure_iot_hub/trunk/asp3_dcre/sample/Makefile	(revision 388)
+++ azure_iot_hub/trunk/asp3_dcre/sample/Makefile	(revision 389)
@@ -9,47 +9,32 @@
 #              Graduate School of Information Science, Nagoya Univ., JAPAN
 # 
-#  ä¸è¨èä½æ¨©è
-ã¯ï¼ä»¥ä¸ã®(1)ï½(4)ã®æ¡ä»¶ãæºããå ´åã«éãï¼æ¬ã½ããã¦ã§
-#  ã¢ï¼æ¬ã½ããã¦ã§ã¢ãæ¹å¤ãããã®ãå«ãï¼ä»¥ä¸åãï¼ãä½¿ç¨ã»è¤è£½ã»æ¹
-#  å¤ã»åé
-å¸ï¼ä»¥ä¸ï¼å©ç¨ã¨å¼ã¶ï¼ãããã¨ãç¡åã§è¨±è«¾ããï¼
-#  (1) æ¬ã½ããã¦ã§ã¢ãã½ã¼ã¹ã³ã¼ãã®å½¢ã§å©ç¨ããå ´åã«ã¯ï¼ä¸è¨ã®èä½
-#      æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãï¼ãã®ã¾ã¾ã®å½¢ã§ã½ã¼
-#      ã¹ã³ã¼ãä¸­ã«å«ã¾ãã¦ãããã¨ï¼
-#  (2) æ¬ã½ããã¦ã§ã¢ãï¼ã©ã¤ãã©ãªå½¢å¼ãªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
-#      ç¨ã§ããå½¢ã§åé
-å¸ããå ´åã«ã¯ï¼åé
-å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨
-#      è
-ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®èä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨
-#      ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
-#  (3) æ¬ã½ããã¦ã§ã¢ãï¼æ©å¨ã«çµã¿è¾¼ããªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
-#      ç¨ã§ããªãå½¢ã§åé
-å¸ããå ´åã«ã¯ï¼æ¬¡ã®ããããã®æ¡ä»¶ãæºããã
-#      ã¨ï¼
-#    (a) åé
-å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨è
-ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®è
-#        ä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
-#    (b) åé
-å¸ã®å½¢æ
-ãï¼å¥ã«å®ããæ¹æ³ã«ãã£ã¦ï¼TOPPERSãã­ã¸ã§ã¯ãã«
-#        å ±åãããã¨ï¼
-#  (4) æ¬ã½ããã¦ã§ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæ
-#      å®³ãããï¼ä¸è¨èä½æ¨©è
-ããã³TOPPERSãã­ã¸ã§ã¯ããå
-è²¬ãããã¨ï¼
-#      ã¾ãï¼æ¬ã½ããã¦ã§ã¢ã®ã¦ã¼ã¶ã¾ãã¯ã¨ã³ãã¦ã¼ã¶ããã®ãããªãç
-#      ç±ã«åºã¥ãè«æ±ãããï¼ä¸è¨èä½æ¨©è
-ããã³TOPPERSãã­ã¸ã§ã¯ãã
-#      å
-è²¬ãããã¨ï¼
+#  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+#  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+#  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+#  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+#      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+#      スコード中に含まれていること．
+#  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+#      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+#      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+#      の無保証規定を掲載すること．
+#  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+#      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+#      と．
+#    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+#        作権表示，この利用条件および下記の無保証規定を掲載すること．
+#    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+#        報告すること．
+#  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+#      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+#      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+#      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+#      免責すること．
 # 
-#  æ¬ã½ããã¦ã§ã¢ã¯ï¼ç¡ä¿è¨¼ã§æä¾ããã¦ãããã®ã§ããï¼ä¸è¨èä½æ¨©è
-ã
-#  ãã³TOPPERSãã­ã¸ã§ã¯ãã¯ï¼æ¬ã½ããã¦ã§ã¢ã«é¢ãã¦ï¼ç¹å®ã®ä½¿ç¨ç®ç
-#  ã«å¯¾ããé©åæ§ãå«ãã¦ï¼ãããªãä¿è¨¼ãè¡ããªãï¼ã¾ãï¼æ¬ã½ããã¦ã§
-#  ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæå®³ã«é¢ãã¦ãï¼ã
-#  ã®è²¬ä»»ãè² ããªãï¼
+#  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+#  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+#  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+#  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+#  の責任を負わない．
 # 
 #  $Id$
@@ -57,15 +42,15 @@
 
 #
-#  ã¿ã¼ã²ããã®æå®ï¼Makefile.targetã§ä¸æ¸ããããã®ãé²ãããï¼
+#  ターゲットの指定（Makefile.targetで上書きされるのを防ぐため）
 #
 all:
 
 #
-#  ã¿ã¼ã²ããç¥ç§°ã®å®ç¾©
+#  ターゲット略称の定義
 #
 TARGET = @(TARGET)
 
 #
-#  ãã­ã°ã©ãã³ã°è¨èªã®å®ç¾©
+#  プログラミング言語の定義
 #
 SRCLANG = @(SRCLANG)
@@ -80,41 +65,41 @@
 
 #
-#  ã½ã¼ã¹ãã¡ã¤ã«ã®ãã£ã¬ã¯ããªã®å®ç¾©
+#  ソースファイルのディレクトリの定義
 #
 SRCDIR = @(SRCDIR)
 
 #
-#  ãªãã¸ã§ã¯ããã¡ã¤ã«åã®æ¡å¼µå­ã®è¨­å®
+#  オブジェクトファイル名の拡張子の設定
 #
 OBJEXT = @(OBJEXT)
 
 #
-#  ã«ã¼ãã«ã©ã¤ãã©ãªï¼libkernel.aï¼ã®ãã£ã¬ã¯ããªå
-#  ï¼ã«ã¼ãã«ã©ã¤ãã©ãªãmakeå¯¾è±¡ã«ããæã¯ï¼ç©ºã«å®ç¾©ããï¼
+#  カーネルライブラリ（libkernel.a）のディレクトリ名
+#  （カーネルライブラリもmake対象にする時は，空に定義する）
 #
 KERNEL_LIB = @(KERNEL_LIB)
 
 #
-#  ã«ã¼ãã«ãé¢æ°åä½ã§ã³ã³ãã¤ã«ãããã©ããã®å®ç¾©
+#  カーネルを関数単位でコンパイルするかどうかの定義
 #
 KERNEL_FUNCOBJS = @(KERNEL_FUNCOBJS)
 
 #
-#  TECSãå¤ããã©ããã®å®ç¾©
+#  TECSを外すかどうかの定義
 #
 OMIT_TECS = @(OMIT_TECS)
 
 #
-#  ãã¬ã¼ã¹ã­ã°ãåå¾ãããã©ããã®å®ç¾©
+#  トレースログを取得するかどうかの定義
 #
 ENABLE_TRACE = @(ENABLE_TRACE)
 
 #
-#  éçºãã¼ã«ï¼ã³ã³ãã¤ã©ç­ï¼ã®ãã£ã¬ã¯ããªã®å®ç¾©
+#  開発ツール（コンパイラ等）のディレクトリの定義
 #
 DEVTOOLDIR = @(DEVTOOLDIR)
 
 #
-#  ã¦ã¼ãã£ãªãã£ãã­ã°ã©ã ã®åç§°
+#  ユーティリティプログラムの名称
 #
 CFG = @(CFG)
@@ -122,5 +107,5 @@
 
 #
-#  ãªãã¸ã§ã¯ããã¡ã¤ã«åã®å®ç¾©
+#  オブジェクトファイル名の定義
 #
 OBJNAME = asp
@@ -134,20 +119,20 @@
 
 #
-#  ä¾å­é¢ä¿ãã¡ã¤ã«ãç½®ããã£ã¬ã¯ããªã®å®ç¾©
+#  依存関係ファイルを置くディレクトリの定義
 #
 DEPDIR = @(DEPDIR)
 
 #
-#  ã¿ã¼ã²ããä¾å­é¨ã®ãã£ã¬ã¯ããªã®å®ç¾©
+#  ターゲット依存部のディレクトリの定義
 #
 TARGETDIR = $(SRCDIR)/target/$(TARGET)
 
 #
-#  ã¿ã¼ã²ããä¾å­ã®å®ç¾©ã®ã¤ã³ã¯ã«ã¼ã
+#  ターゲット依存の定義のインクルード
 #
 include $(TARGETDIR)/Makefile.target
 
 #
-#  TECSçæãã¡ã¤ã«ã®ãã£ã¬ã¯ããªã®å®ç¾©
+#  TECS生成ファイルのディレクトリの定義
 #
 TECSGENDIR = ./gen
@@ -158,5 +143,5 @@
 
 #
-#  TECSãçæããå®ç¾©ã®ã¤ã³ã¯ã«ã¼ã
+#  TECSが生成する定義のインクルード
 #
 ifndef OMIT_TECS
@@ -166,6 +151,5 @@
 
 #
-#  å
-±éã³ã³ãã¤ã«ãªãã·ã§ã³ã®å®ç¾©
+#  共通コンパイルオプションの定義
 #
 COPTS := -g @(COPTS) $(COPTS)
@@ -186,5 +170,5 @@
 
 #
-#  ã¢ããªã±ã¼ã·ã§ã³ãã­ã°ã©ã ã«é¢ããå®ç¾©
+#  アプリケーションプログラムに関する定義
 #
 APPLNAME = @(APPLNAME)
@@ -208,27 +192,27 @@
 
 #
-#  ãããã¯ã¼ã¯ãµã¼ãã¹ã®å®ç¾©
+#  ネットワークサービスの定義
 #
 
 NO_USE_TINET_LIBRARY = true
 
-#  ãããã¯ã¼ã¯ã¤ã³ã¿ãã§ã¼ã¹ã®é¸æãä½ããä¸ã¤é¸æããã
+#  ネットワークインタフェースの選択、何れか一つ選択する。
 
 NET_IF = ether
 
-#  ã¤ã¼ãµãããã»ãã£ãã¤ã¹ãã©ã¤ãã®é¸æ
+#  イーサネット・ディバイスドライバの選択
 
 NET_DEV = if_mbed
 
-#  ãããã¯ã¼ã¯å±¤ã®é¸æ
+#  ネットワーク層の選択
 
 #SUPPORT_INET6 = true
 SUPPORT_INET4 = true
 
-#  API ã«çµè¾¼ãæ©è½ã®é¸æ
+#  API に組込む機能の選択
 
 #API_CFG_IP4MAPPED_ADDR = true
 
-#  ãã©ã³ã¹ãã¼ãå±¤ã®é¸æ
+#  トランスポート層の選択
 
 SUPPORT_TCP = true
@@ -236,10 +220,10 @@
 
 #
-#  ã·ã¹ãã ãµã¼ãã¹ã® Makefile ã®ã¤ã³ã¯ã«ã¼ã
+#  システムサービスの Makefile のインクルード
 #
 include $(SRCDIR)/tinet/Makefile.tinet
 
 #
-#  ã·ã¹ãã ãµã¼ãã¹ã«é¢ããå®ç¾©
+#  システムサービスに関する定義
 #
 SYSSVC_DIRS := $(TECSGENDIR) $(SRCDIR)/tecs_kernel \
@@ -252,5 +236,5 @@
 
 #
-#  ã¿ã¼ã²ãããã¡ã¤ã«
+#  ターゲットファイル
 #
 .PHONY: all
@@ -266,8 +250,8 @@
 endif
 
-##### ä»¥ä¸ã¯ç·¨éããªããã¨ #####
-
-#
-#  ã³ã³ãã£ã®ã¥ã¬ã¼ã¿ã«é¢ããå®ç¾©
+##### 以下は編集しないこと #####
+
+#
+#  コンフィギュレータに関する定義
 #
 CFG_TABS := --api-table $(SRCDIR)/tinet/tcpip_api.def:tcpip \
@@ -282,14 +266,14 @@
 
 #
-#  ã«ã¼ãã«ã«é¢ããå®ç¾©
-#
-#  KERNEL_ASMOBJS: ã«ã¼ãã«ã©ã¤ãã©ãªã«å«ããï¼ã½ã¼ã¹ãã¢ã»ã³ããªè¨èªã®
-#				   ãªãã¸ã§ã¯ããã¡ã¤ã«ï¼
-#  KERNEL_COBJS: ã«ã¼ãã«ã®ã©ã¤ãã©ãªã«å«ããï¼ã½ã¼ã¹ãCè¨èªã§ï¼ã½ã¼ã¹
-#				 ãã¡ã¤ã«ã¨1å¯¾1ã«å¯¾å¿ãããªãã¸ã§ã¯ããã¡ã¤ã«ï¼
-#  KERNEL_LCSRCS: ã«ã¼ãã«ã®ã©ã¤ãã©ãªã«å«ããCè¨èªã®ã½ã¼ã¹ãã¡ã¤ã«ã§ï¼
-#				  1ã¤ã®ã½ã¼ã¹ãã¡ã¤ã«ããè¤æ°ã®ãªãã¸ã§ã¯ããã¡ã¤ã«ãç
-#				  æãããã®ï¼
-#  KERNEL_LCOBJS: ä¸ã®ã½ã¼ã¹ãã¡ã¤ã«ããçæããããªãã¸ã§ã¯ããã¡ã¤ã«ï¼
+#  カーネルに関する定義
+#
+#  KERNEL_ASMOBJS: カーネルライブラリに含める，ソースがアセンブリ言語の
+#				   オブジェクトファイル．
+#  KERNEL_COBJS: カーネルのライブラリに含める，ソースがC言語で，ソース
+#				 ファイルと1対1に対応するオブジェクトファイル．
+#  KERNEL_LCSRCS: カーネルのライブラリに含めるC言語のソースファイルで，
+#				  1つのソースファイルから複数のオブジェクトファイルを生
+#				  成するもの．
+#  KERNEL_LCOBJS: 上のソースファイルから生成されるオブジェクトファイル．
 #
 KERNEL_DIRS := $(KERNEL_DIRS) $(SRCDIR)/kernel
@@ -299,5 +283,5 @@
 
 #
-#  ã«ã¼ãã«ã®ãã¡ã¤ã«æ§æã®å®ç¾©
+#  カーネルのファイル構成の定義
 #
 include $(SRCDIR)/kernel/Makefile.kernel
@@ -332,5 +316,5 @@
 
 #
-#  ã½ã¼ã¹ãã¡ã¤ã«ã®ãããã£ã¬ã¯ããªã«é¢ããå®ç¾©
+#  ソースファイルのあるディレクトリに関する定義
 #
 vpath %.c $(KERNEL_DIRS) $(SYSSVC_DIRS) $(APPL_DIRS)
@@ -340,5 +324,5 @@
 
 #
-#  ã³ã³ãã¤ã«ã®ããã®å¤æ°ã®å®ç¾©
+#  コンパイルのための変数の定義
 #
 KERNEL_LIB_OBJS = $(KERNEL_ASMOBJS) $(KERNEL_COBJS) $(KERNEL_LCOBJS)
@@ -368,10 +352,10 @@
 
 #
-#  tecsgenããCããªãã­ã»ããµãå¼ã³åºãéã®ãªãã·ã§ã³ã®å®ç¾©
+#  tecsgenからCプリプロセッサを呼び出す際のオプションの定義
 #
 TECS_CPP = $(CC) $(CDEFS) $(INCLUDES) $(SYSSVC_CFLAGS) -D TECSGEN -E
 
 #
-#  tecsgenã®å¼åºã
+#  tecsgenの呼出し
 #
 .PHONY: tecs
@@ -381,5 +365,5 @@
 
 #
-#  ã«ã¼ãã«ã®ã³ã³ãã£ã®ã¥ã¬ã¼ã·ã§ã³ãã¡ã¤ã«ã®çæ
+#  カーネルのコンフィギュレーションファイルの生成
 #
 cfg1_out.c cfg1_out.db: cfg1_out.timestamp ;
@@ -403,5 +387,5 @@
 
 #
-#  ãªãã»ãããã¡ã¤ã«ï¼offset.hï¼ã®çæè¦å
+#  オフセットファイル（offset.h）の生成規則
 #
 $(OFFSET_H): offset.timestamp ;
@@ -411,5 +395,5 @@
 
 #
-#  ã«ã¼ãã«ã©ã¤ãã©ãªãã¡ã¤ã«ã®çæ
+#  カーネルライブラリファイルの生成
 #
 libkernel.a: $(OFFSET_H) $(KERNEL_LIB_OBJS)
@@ -419,5 +403,5 @@
 
 #
-#  ä¸¦åmakeã®ããã®ä¾å­é¢ä¿ã®å®ç¾©
+#  並列makeのための依存関係の定義
 #
 $(APPL_OBJS) $(SYSSVC_OBJS): | kernel_cfg.timestamp
@@ -426,11 +410,10 @@
 
 #
-#  ç¹å¥ãªä¾å­é¢ä¿ã®å®ç¾©
+#  特別な依存関係の定義
 #
 tBannerMain.o: $(filter-out tBannerMain.o,$(ALL_OBJS)) $(LIBS_DEP)
 
 #
-#  å
-¨ä½ã®ãªã³ã¯
+#  全体のリンク
 #
 $(OBJFILE): $(ALL_OBJS) $(LIBS_DEP)
@@ -440,5 +423,5 @@
 
 #
-#  ä¾å­é¢ä¿ãã©ã«ãã®ä½æ
+#  依存関係フォルダの作成
 #
 $(DEPDIR):
@@ -446,5 +429,5 @@
 
 #
-#  ã·ã³ãã«ãã¡ã¤ã«ã®çæ
+#  シンボルファイルの生成
 #
 $(OBJNAME).syms: $(OBJFILE)
@@ -452,5 +435,5 @@
 
 #
-#  ãã¤ããªãã¡ã¤ã«ã®çæ
+#  バイナリファイルの生成
 #
 $(OBJNAME).bin: $(OBJFILE)
@@ -458,5 +441,5 @@
 
 #
-#  Sã¬ã³ã¼ããã¡ã¤ã«ã®çæ
+#  Sレコードファイルの生成
 #
 $(OBJNAME).srec: $(OBJFILE)
@@ -464,5 +447,5 @@
 
 #
-#  ã¨ã©ã¼ãã§ãã¯å¦ç
+#  エラーチェック処理
 #
 .PHONY: check
@@ -474,5 +457,5 @@
 
 #
-#  ã³ã³ãã¤ã«çµæã®æ¶å»
+#  コンパイル結果の消去
 #
 .PHONY: clean
@@ -499,9 +482,8 @@
 
 #
-#  ã³ã³ãã£ã®ã¥ã¬ã¼ã¿ãçæãããã¡ã¤ã«ã®ã³ã³ãã¤ã«ã«ã¼ã«ã®å®ç¾©
-#
-#  ã³ã³ãã£ã®ã¥ã¬ã¼ã¿ãçæãããã¡ã¤ã«ã¯ï¼å
-±éã®ã³ã³ãã¤ã«ãªãã·ã§ã³
-#  ã®ã¿ãä»ãã¦ã³ã³ãã¤ã«ããï¼
+#  コンフィギュレータが生成したファイルのコンパイルルールの定義
+#
+#  コンフィギュレータが生成したファイルは，共通のコンパイルオプション
+#  のみを付けてコンパイルする．
 #
 ALL_CFG_COBJS = $(CFG_COBJS) cfg1_out.o
@@ -518,14 +500,14 @@
 
 #
-#  ä¾å­é¢ä¿ãã¡ã¤ã«ã®ã¤ã³ã¯ã«ã¼ã
+#  依存関係ファイルのインクルード
 #
 -include $(DEPDIR)/*.d
 
 #
-#  éçºãã¼ã«ã®ã³ãã³ãåã®å®ç¾©
+#  開発ツールのコマンド名の定義
 #
 ifeq ($(TOOL),gcc)
 	#
-	#  GNUéçºç°å¢ç¨
+	#  GNU開発環境用
 	#
 	ifdef GCC_TARGET
@@ -564,5 +546,5 @@
 
 #
-#  ã³ã³ãã¤ã«ã«ã¼ã«ã®å®ç¾©
+#  コンパイルルールの定義
 #
 $(KERNEL_COBJS): %.o: %.c
@@ -607,5 +589,5 @@
 
 #
-#  ããã©ã«ãã³ã³ãã¤ã«ã«ã¼ã«ãä¸æ¸ã
+#  デフォルトコンパイルルールを上書き
 #
 %.o: %.c