Index: /azure_iot_hub/trunk/app_iothub_client/src/client.c
===================================================================
--- /azure_iot_hub/trunk/app_iothub_client/src/client.c	(revision 389)
+++ /azure_iot_hub/trunk/app_iothub_client/src/client.c	(revision 390)
@@ -160,5 +160,5 @@
 	else
 	{
-#if 0
+#if 1
 		(void)printf("Starting the IoTHub client sample HTTP...\r\n");
 		IOTHUB_CLIENT_TRANSPORT_PROVIDER protocol = HTTP_Protocol;
@@ -235,5 +235,5 @@
 						temperature = minTemperature + (rand() % 10);
 						humidity = minHumidity + (rand() % 20);
-                        sprintf_s(msgText, sizeof(msgText), "{\"deviceId\":\"myFirstDevice\",\"windSpeed\":%.2f,\"temperature\":%.2f,\"humidity\":%.2f}", avgWindSpeed + (rand() % 4 + 2), temperature, humidity);
+						sprintf_s(msgText, sizeof(msgText), "{\"windSpeed\":%.2f,\"temperature\":%.2f,\"humidity\":%.2f}", avgWindSpeed + (rand() % 4 + 2), temperature, humidity);
 						if ((messages[iterator].messageHandle = IoTHubMessage_CreateFromByteArray((const unsigned char*)msgText, strlen(msgText))) == NULL)
 						{
Index: /azure_iot_hub/trunk/musl-1.1.18/include/bits/alltypes.h
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/include/bits/alltypes.h	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/include/bits/alltypes.h	(revision 390)
@@ -1,8 +1,2 @@
-#ifdef _MSC_VER
-#define __builtin_va_list char *
-#define __NEED_va_list
-#define restrict __restrict
-#endif
-
 #define _Addr int
 #define _Int64 long long
@@ -46,9 +40,5 @@
 
 #if defined(__NEED_time_t) && !defined(__DEFINED_time_t)
-#if defined(_MSC_VER) || defined(__c2__)
-typedef long long time_t;
-#else
 typedef long time_t;
-#endif
 #define __DEFINED_time_t
 #endif
Index: /azure_iot_hub/trunk/musl-1.1.18/include/bits/errno.h
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/include/bits/errno.h	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/include/bits/errno.h	(revision 390)
@@ -1,51 +1,2 @@
-#ifdef _INC_ERRNO
-#undef EADDRINUSE
-#undef EADDRNOTAVAIL
-#undef EAFNOSUPPORT
-#undef EALREADY
-#undef EBADMSG
-#undef ECANCELED
-#undef ECONNABORTED
-#undef ECONNREFUSED
-#undef ECONNRESET
-#undef EDEADLK
-#undef EDESTADDRREQ
-#undef EHOSTUNREACH
-#undef EIDRM
-#undef EILSEQ
-#undef EINPROGRESS
-#undef EISCONN
-#undef ELOOP
-#undef EMSGSIZE
-#undef ENAMETOOLONG
-#undef ENETDOWN
-#undef ENETRESET
-#undef ENETUNREACH
-#undef ENOBUFS
-#undef ENODATA
-#undef ENOLCK
-#undef ENOLINK
-#undef ENOMSG
-#undef ENOPROTOOPT
-#undef ENOSR
-#undef ENOSTR
-#undef ENOSYS
-#undef ENOTCONN
-#undef ENOTEMPTY
-#undef ENOTRECOVERABLE
-#undef ENOTSOCK
-#undef ENOTSUP
-#undef EOPNOTSUPP
-#undef EOVERFLOW
-#undef EOWNERDEAD
-#undef EPROTO
-#undef EPROTONOSUPPORT
-#undef EPROTOTYPE
-#undef ETIME
-#undef ETIMEDOUT
-#undef ETXTBSY
-#undef EWOULDBLOCK
-#endif
-
 #define EPERM            1
 #define ENOENT           2
Index: /azure_iot_hub/trunk/musl-1.1.18/include/setjmp.h
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/include/setjmp.h	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/include/setjmp.h	(revision 390)
@@ -33,9 +33,5 @@
 _Noreturn void longjmp (jmp_buf, int);
 
-#if !defined(_MSC_VER) && !defined(__c2__)
-#define setjmp __builtin_setjmp
-#else
 #define setjmp setjmp
-#endif
 
 #ifdef __cplusplus
Index: /azure_iot_hub/trunk/musl-1.1.18/include/stdarg.h
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/include/stdarg.h	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/include/stdarg.h	(revision 390)
@@ -10,25 +10,8 @@
 #include <bits/alltypes.h>
 
-#if !defined(_MSC_VER) && !defined(__c2__)
-
 #define va_start(v,l)   __builtin_va_start(v,l)
 #define va_end(v)       __builtin_va_end(v)
 #define va_arg(v,l)     __builtin_va_arg(v,l)
 #define va_copy(d,s)    __builtin_va_copy(d,s)
-
-#else
-
-#define _INTSIZEOF(n)          ((sizeof(n) + sizeof(int) - 1) & ~(sizeof(int) - 1))
-
-#define __crt_va_start(ap, v)   ((void)(ap = (va_list)&(v) + _INTSIZEOF(v)))
-#define __crt_va_arg(ap, t)     (*(t*)((ap += _INTSIZEOF(t)) - _INTSIZEOF(t)))
-#define __crt_va_end(ap)        ((void)(ap = (va_list)0))
-
-#define va_start __crt_va_start
-#define va_arg   __crt_va_arg
-#define va_end   __crt_va_end
-#define va_copy(destination, source) ((destination) = (source))
-
-#endif
 
 #ifdef __cplusplus
Index: /azure_iot_hub/trunk/musl-1.1.18/include/stdio.h
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/include/stdio.h	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/include/stdio.h	(revision 390)
@@ -22,10 +22,8 @@
 #include <bits/alltypes.h>
 
-#ifndef _UCRT
 #ifdef __cplusplus
 #define NULL 0L
 #else
 #define NULL ((void*)0)
-#endif
 #endif
 
Index: /azure_iot_hub/trunk/musl-1.1.18/src/env/__init_tls.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/env/__init_tls.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/env/__init_tls.c	(revision 390)
@@ -72,7 +72,5 @@
 #endif
 
-#ifndef __c2__
 __attribute__((__weak__, __visibility__("hidden")))
-#endif
 extern const size_t _DYNAMIC[];
 
@@ -136,10 +134,3 @@
 }
 
-#ifndef __c2__
 weak_alias(static_init_tls, __init_tls);
-#else
-void __init_tls(size_t *aux)
-{
-	static_init_tls(aux);
-}
-#endif
Index: /azure_iot_hub/trunk/musl-1.1.18/src/env/__libc_start_main.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/env/__libc_start_main.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/env/__libc_start_main.c	(revision 390)
@@ -9,27 +9,12 @@
 void __init_tls(size_t *);
 
-#ifndef __c2__
 static void dummy(void) {}
 weak_alias(dummy, _init);
-#else
-__attribute((weak))
-void _init(void) {}
-#endif
 
-#ifndef __c2__
 __attribute__((__weak__, __visibility__("hidden")))
 extern void (*const __init_array_start)(void), (*const __init_array_end)(void);
-#else
-extern void(*const __init_array_start)(void);
-#define __init_array_end __init_array_start
-#endif
 
-#ifndef __c2__
 static void dummy1(void *p) {}
 weak_alias(dummy1, __init_ssp);
-#else
-__attribute((weak))
-void __init_ssp(void *p) {}
-#endif
 
 #define AUX_CNT 38
@@ -77,14 +62,5 @@
 }
 
-#ifndef __c2__
 weak_alias(libc_start_init, __libc_start_init);
-#else
-void __libc_start_init(void)
-{
-	libc_start_init();
-}
-#undef exit
-#define exit(x) x
-#endif
 
 int __libc_start_main(int (*main)(int,char **,char **), int argc, char **argv)
Index: /azure_iot_hub/trunk/musl-1.1.18/src/env/clearenv.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/env/clearenv.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/env/clearenv.c	(revision 390)
@@ -3,10 +3,6 @@
 #include "libc.h"
 
-#ifndef __c2__
 static void dummy(char *old, char *new) {}
 weak_alias(dummy, __env_rm_add);
-#else
-extern void __env_rm_add(char *old, char *new);
-#endif
 
 int clearenv()
Index: /azure_iot_hub/trunk/musl-1.1.18/src/env/putenv.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/env/putenv.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/env/putenv.c	(revision 390)
@@ -5,10 +5,6 @@
 char *__strchrnul(const char *, int);
 
-#ifndef __c2__
 static void dummy(char *old, char *new) {}
 weak_alias(dummy, __env_rm_add);
-#else
-extern void __env_rm_add(char *old, char *new);
-#endif
 
 int __putenv(char *s, size_t l, char *r)
Index: /azure_iot_hub/trunk/musl-1.1.18/src/env/unsetenv.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/env/unsetenv.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/env/unsetenv.c	(revision 390)
@@ -6,10 +6,6 @@
 char *__strchrnul(const char *, int);
 
-#ifndef __c2__
 static void dummy(char *old, char *new) {}
 weak_alias(dummy, __env_rm_add);
-#else
-extern void __env_rm_add(char *old, char *new);
-#endif
 
 int unsetenv(const char *name)
Index: /azure_iot_hub/trunk/musl-1.1.18/src/exit/exit.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/exit/exit.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/exit/exit.c	(revision 390)
@@ -3,5 +3,4 @@
 #include "libc.h"
 
-#ifndef __c2__
 static void dummy()
 {
@@ -13,11 +12,4 @@
 weak_alias(dummy, __stdio_exit);
 weak_alias(dummy, _fini);
-#else
-__attribute__((weak))
-void __funcs_on_exit() { }
-void __stdio_exit();
-__attribute__((weak))
-void _fini() { }
-#endif
 
 __attribute__((__weak__, __visibility__("hidden")))
@@ -32,9 +24,5 @@
 }
 
-#ifndef __c2__
 weak_alias(libc_exit_fini, __libc_exit_fini);
-#else
-void __libc_exit_fini(void);
-#endif
 
 _Noreturn void exit(int code)
Index: /azure_iot_hub/trunk/musl-1.1.18/src/internal/atomic.h
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/internal/atomic.h	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/internal/atomic.h	(revision 390)
@@ -195,5 +195,5 @@
 #ifndef a_barrier
 #define a_barrier a_barrier
-static inline void a_barrier()
+static void a_barrier()
 {
 	volatile int tmp = 0;
Index: /azure_iot_hub/trunk/musl-1.1.18/src/ldso/dl_iterate_phdr.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/ldso/dl_iterate_phdr.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/ldso/dl_iterate_phdr.c	(revision 390)
@@ -5,7 +5,5 @@
 #define AUX_CNT 38
 
-#ifndef __c2__
 __attribute__((__weak__, __visibility__("hidden")))
-#endif
 extern const size_t _DYNAMIC[];
 
Index: /azure_iot_hub/trunk/musl-1.1.18/src/ldso/tlsdesc.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/ldso/tlsdesc.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/ldso/tlsdesc.c	(revision 390)
@@ -10,10 +10,3 @@
 }
 
-#ifndef __c2__
 weak_alias(__tlsdesc_static, __tlsdesc_dynamic);
-#else
-ptrdiff_t __tlsdesc_dynamic()
-{
-	return __tlsdesc_static();
-}
-#endif
Index: /azure_iot_hub/trunk/musl-1.1.18/src/mman/mmap.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/mman/mmap.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/mman/mmap.c	(revision 390)
@@ -7,10 +7,6 @@
 #include "libc.h"
 
-#ifndef __c2__
 static void dummy(void) { }
 weak_alias(dummy, __vm_wait);
-#else
-extern void __vm_wait(void);
-#endif
 
 #define UNIT SYSCALL_MMAP2_UNIT
@@ -42,12 +38,5 @@
 }
 
-#ifndef __c2__
 weak_alias(__mmap, mmap);
-#else
-void *mmap(void *start, size_t len, int prot, int flags, int fd, off_t off)
-{
-	return __mmap(start, len, prot, flags, fd, off);
-}
-#endif
 
 LFS64(mmap);
Index: /azure_iot_hub/trunk/musl-1.1.18/src/mman/mprotect.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/mman/mprotect.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/mman/mprotect.c	(revision 390)
@@ -11,10 +11,3 @@
 }
 
-#ifndef __c2__
 weak_alias(__mprotect, mprotect);
-#else
-int mprotect(void *addr, size_t len, int prot)
-{
-	return __mprotect(addr, len, prot);
-}
-#endif
Index: /azure_iot_hub/trunk/musl-1.1.18/src/mman/mremap.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/mman/mremap.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/mman/mremap.c	(revision 390)
@@ -8,10 +8,6 @@
 #include "libc.h"
 
-#ifndef __c2__
 static void dummy(void) { }
 weak_alias(dummy, __vm_wait);
-#else
-extern void __vm_wait(void);
-#endif
 
 void *__mremap(void *old_addr, size_t old_len, size_t new_len, int flags, ...)
Index: /azure_iot_hub/trunk/musl-1.1.18/src/mman/munmap.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/mman/munmap.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/mman/munmap.c	(revision 390)
@@ -3,10 +3,6 @@
 #include "libc.h"
 
-#ifndef __c2__
 static void dummy(void) { }
 weak_alias(dummy, __vm_wait);
-#else
-extern void __vm_wait(void);
-#endif
 
 int __munmap(void *start, size_t len)
@@ -16,10 +12,3 @@
 }
 
-#ifndef __c2__
 weak_alias(__munmap, munmap);
-#else
-int munmap(void *start, size_t len)
-{
-	return __munmap(start, len);
-}
-#endif
Index: /azure_iot_hub/trunk/musl-1.1.18/src/process/fork.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/process/fork.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/process/fork.c	(revision 390)
@@ -6,5 +6,4 @@
 #include "pthread_impl.h"
 
-#ifndef __c2__
 static void dummy(int x)
 {
@@ -12,7 +11,4 @@
 
 weak_alias(dummy, __fork_handler);
-#else
-extern void __fork_handler(int x);
-#endif
 
 pid_t fork(void)
Index: /azure_iot_hub/trunk/musl-1.1.18/src/stdio/__fdopen.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/stdio/__fdopen.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/stdio/__fdopen.c	(revision 390)
@@ -58,10 +58,3 @@
 }
 
-#ifndef __c2__
 weak_alias(__fdopen, fdopen);
-#else
-FILE *fdopen(int fd, const char *mode)
-{
-	return __fdopen(fd, mode);
-}
-#endif
Index: /azure_iot_hub/trunk/musl-1.1.18/src/stdio/__stdio_close.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/stdio/__stdio_close.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/stdio/__stdio_close.c	(revision 390)
@@ -1,5 +1,4 @@
 #include "stdio_impl.h"
 
-#ifndef __c2__
 static int dummy(int fd)
 {
@@ -8,7 +7,4 @@
 
 weak_alias(dummy, __aio_close);
-#else
-extern int __aio_close(int fd);
-#endif
 
 int __stdio_close(FILE *f)
Index: /azure_iot_hub/trunk/musl-1.1.18/src/stdio/__stdio_exit.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/stdio/__stdio_exit.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/stdio/__stdio_exit.c	(revision 390)
@@ -1,13 +1,8 @@
 #include "stdio_impl.h"
 
-#ifndef __c2__
 static FILE *volatile dummy_file = 0;
 weak_alias(dummy_file, __stdin_used);
 weak_alias(dummy_file, __stdout_used);
 weak_alias(dummy_file, __stderr_used);
-#else
-extern FILE *volatile __stdin_used;
-extern FILE *volatile __stdout_used;
-#endif
 
 static void close_file(FILE *f)
@@ -27,10 +22,3 @@
 }
 
-#ifndef __c2__
 weak_alias(__stdio_exit, __stdio_exit_needed);
-#else
-void __stdio_exit_needed(void)
-{
-	__stdio_exit();
-}
-#endif
Index: /azure_iot_hub/trunk/musl-1.1.18/src/stdio/fflush.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/stdio/fflush.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/stdio/fflush.c	(revision 390)
@@ -2,10 +2,6 @@
 
 /* stdout.c will override this if linked */
-#ifndef __c2__
 static FILE *volatile dummy = 0;
 weak_alias(dummy, __stdout_used);
-#else
-extern FILE *volatile __stdout_used;
-#endif
 
 int fflush(FILE *f)
@@ -46,10 +42,3 @@
 }
 
-#ifndef __c2__
 weak_alias(fflush, fflush_unlocked);
-#else
-int fflush_unlocked(FILE *f)
-{
-	return fflush_unlocked(f);
-}
-#endif
Index: /azure_iot_hub/trunk/musl-1.1.18/src/stdio/fwrite.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/stdio/fwrite.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/stdio/fwrite.c	(revision 390)
@@ -36,10 +36,3 @@
 }
 
-#ifndef __c2__
 weak_alias(fwrite, fwrite_unlocked);
-#else
-size_t fwrite_unlocked(const void *restrict src, size_t size, size_t nmemb, FILE *restrict f)
-{
-	return fwrite(src, size, nmemb, f);
-}
-#endif
Index: /azure_iot_hub/trunk/musl-1.1.18/src/stdio/vsnprintf.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/stdio/vsnprintf.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/stdio/vsnprintf.c	(revision 390)
@@ -54,9 +54,2 @@
 	return vfprintf(&f, fmt, ap);
 }
-
-#ifdef __c2__
-int _vsnprintf(char *restrict s, size_t n, const char *restrict fmt, va_list ap)
-{
-	return vsnprintf(s, n, fmt, ap);
-}
-#endif
Index: /azure_iot_hub/trunk/musl-1.1.18/src/stdio/vsscanf.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/stdio/vsscanf.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/stdio/vsscanf.c	(revision 390)
@@ -17,11 +17,2 @@
 
 weak_alias(vsscanf,__isoc99_vsscanf);
-
-#ifdef __c2__
-void _vacopy(va_list a, va_list b)
-{
-	void *c;
-	c = *(void **)b;
-	*(void **)a = &c;
-}
-#endif
Index: /azure_iot_hub/trunk/musl-1.1.18/src/thread/__set_thread_area.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/thread/__set_thread_area.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/thread/__set_thread_area.c	(revision 390)
@@ -3,13 +3,5 @@
 int __set_thread_area(void *p)
 {
-#ifndef __c2__
 	__asm__ __volatile__ ( "mvtc %0, fintv" : : "r"(p) : "memory" );
 	return 0;
-#else
-#ifdef SYS_set_thread_area
-	return __syscall(SYS_set_thread_area, p);
-#else
-	return -ENOSYS;
-#endif
-#endif
 }
Index: /azure_iot_hub/trunk/musl-1.1.18/src/thread/__syscall_cp.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/thread/__syscall_cp.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/thread/__syscall_cp.c	(revision 390)
@@ -2,5 +2,4 @@
 #include "syscall.h"
 
-#undef sccp
 __attribute__((__visibility__("hidden")))
 long __syscall_cp_c();
@@ -13,14 +12,5 @@
 }
 
-#ifndef __c2__
 weak_alias(sccp, __syscall_cp_c);
-#else
-long __syscall_cp_c(syscall_arg_t nr,
-	syscall_arg_t u, syscall_arg_t v, syscall_arg_t w,
-	syscall_arg_t x, syscall_arg_t y, syscall_arg_t z)
-{
-	return sccp(nr, u, v, w, x, y, z);
-}
-#endif
 
 long (__syscall_cp)(syscall_arg_t nr,
Index: /azure_iot_hub/trunk/musl-1.1.18/src/thread/__tls_get_addr.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/thread/__tls_get_addr.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/thread/__tls_get_addr.c	(revision 390)
@@ -14,5 +14,3 @@
 }
 
-#ifndef __c2__
 weak_alias(__tls_get_addr, __tls_get_new);
-#endif
Index: /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_cleanup_push.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_cleanup_push.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_cleanup_push.c	(revision 390)
@@ -1,5 +1,4 @@
 #include "pthread_impl.h"
 
-#ifndef __c2__
 static void dummy(struct __ptcb *cb)
 {
@@ -7,8 +6,4 @@
 weak_alias(dummy, __do_cleanup_push);
 weak_alias(dummy, __do_cleanup_pop);
-#else
-extern void __do_cleanup_push(struct __ptcb *cb);
-extern void __do_cleanup_pop(struct __ptcb *cb);
-#endif
 
 void _pthread_cleanup_push(struct __ptcb *cb, void (*f)(void *), void *x)
Index: /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_cond_timedwait.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_cond_timedwait.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_cond_timedwait.c	(revision 390)
@@ -212,10 +212,3 @@
 }
 
-#ifndef __c2__
 weak_alias(__pthread_cond_timedwait, pthread_cond_timedwait);
-#else
-int pthread_cond_timedwait(pthread_cond_t *restrict c, pthread_mutex_t *restrict m, const struct timespec *restrict ts)
-{
-	return __pthread_cond_timedwait(c, m, ts);
-}
-#endif
Index: /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_create.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_create.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_create.c	(revision 390)
@@ -14,11 +14,6 @@
 {
 }
-#ifndef __c2__
 weak_alias(dummy_0, __acquire_ptc);
 weak_alias(dummy_0, __release_ptc);
-#else
-extern void __acquire_ptc();
-extern void __release_ptc();
-#endif
 weak_alias(dummy_0, __pthread_tsd_run_dtors);
 weak_alias(dummy_0, __do_orphaned_stdio_locks);
@@ -168,13 +163,8 @@
 
 /* pthread_key_create.c overrides this */
-#ifndef __c2__
 static volatile size_t dummy = 0;
 weak_alias(dummy, __pthread_tsd_size);
 static void *dummy_tsd[1] = { 0 };
 weak_alias(dummy_tsd, __pthread_tsd_main);
-#else
-extern volatile size_t __pthread_tsd_size;
-extern void *__pthread_tsd_main;
-#endif
 
 volatile int __block_new_threads = 0;
@@ -182,14 +172,8 @@
 size_t __default_guardsize = DEFAULT_GUARD_SIZE;
 
-#ifndef __c2__
 static FILE *volatile dummy_file = 0;
 weak_alias(dummy_file, __stdin_used);
 weak_alias(dummy_file, __stdout_used);
 weak_alias(dummy_file, __stderr_used);
-#else
-extern FILE *volatile __stdin_used;
-extern FILE *volatile __stdout_used;
-extern FILE *volatile __stderr_used;
-#endif
 
 static void init_file_lock(FILE *f)
@@ -329,16 +313,4 @@
 }
 
-#ifndef __c2__
 weak_alias(__pthread_exit, pthread_exit);
 weak_alias(__pthread_create, pthread_create);
-#else
-_Noreturn void pthread_exit(void *result)
-{
-	__pthread_exit(result);
-}
-
-int pthread_create(pthread_t *restrict res, const pthread_attr_t *restrict attrp, void *(*entry)(void *), void *restrict arg)
-{
-	return __pthread_create(res, attrp, entry, arg);
-}
-#endif
Index: /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_mutex_lock.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_mutex_lock.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_mutex_lock.c	(revision 390)
@@ -12,10 +12,3 @@
 }
 
-#ifndef __c2__
 weak_alias(__pthread_mutex_lock, pthread_mutex_lock);
-#else
-int pthread_mutex_lock(pthread_mutex_t *m)
-{
-	return __pthread_mutex_lock(m);
-}
-#endif
Index: /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_mutex_trylock.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_mutex_trylock.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_mutex_trylock.c	(revision 390)
@@ -56,10 +56,3 @@
 }
 
-#ifndef __c2__
 weak_alias(__pthread_mutex_trylock, pthread_mutex_trylock);
-#else
-int pthread_mutex_trylock(pthread_mutex_t *m)
-{
-	return __pthread_mutex_trylock(m);
-}
-#endif
Index: /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_mutex_unlock.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_mutex_unlock.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_mutex_unlock.c	(revision 390)
@@ -35,10 +35,3 @@
 }
 
-#ifndef __c2__
 weak_alias(__pthread_mutex_unlock, pthread_mutex_unlock);
-#else
-int pthread_mutex_unlock(pthread_mutex_t *m)
-{
-	return __pthread_mutex_unlock(m);
-}
-#endif
Index: /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_self.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_self.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_self.c	(revision 390)
@@ -8,16 +8,4 @@
 }
 
-#ifndef __c2__
 weak_alias(__pthread_self_internal, pthread_self);
 weak_alias(__pthread_self_internal, thrd_current);
-#else
-pthread_t pthread_self()
-{
-	return __pthread_self_internal();
-}
-
-pthread_t thrd_current()
-{
-	return __pthread_self_internal();
-}
-#endif
Index: /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_setcancelstate.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_setcancelstate.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_setcancelstate.c	(revision 390)
@@ -10,10 +10,3 @@
 }
 
-#ifndef __c2__
 weak_alias(__pthread_setcancelstate, pthread_setcancelstate);
-#else
-int pthread_setcancelstate(int new, int *old)
-{
-	return __pthread_setcancelstate(new, old);
-}
-#endif
Index: /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_testcancel.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_testcancel.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/thread/pthread_testcancel.c	(revision 390)
@@ -13,10 +13,3 @@
 }
 
-#ifndef __c2__
 weak_alias(__pthread_testcancel, pthread_testcancel);
-#else
-void pthread_testcancel()
-{
-	__pthread_testcancel();
-}
-#endif
Index: /azure_iot_hub/trunk/musl-1.1.18/src/thread/synccall.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/thread/synccall.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/thread/synccall.c	(revision 390)
@@ -18,10 +18,6 @@
 static volatile int target_tid;
 static void (*callback)(void *), *context;
-#ifndef __c2__
 static volatile int dummy = 0;
 weak_alias(dummy, __block_new_threads);
-#else
-extern volatile int __block_new_threads;
-#endif
 
 static void handler(int sig)
Index: /azure_iot_hub/trunk/musl-1.1.18/src/time/clock_gettime.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/time/clock_gettime.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/time/clock_gettime.c	(revision 390)
@@ -56,10 +56,3 @@
 }
 
-#ifndef __c2__
 weak_alias(__clock_gettime, clock_gettime);
-#else
-int clock_gettime(clockid_t clk, struct timespec *ts)
-{
-	return __clock_gettime(clk, ts);
-}
-#endif
Index: /azure_iot_hub/trunk/musl-1.1.18/src/time/gmtime_r.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/time/gmtime_r.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/time/gmtime_r.c	(revision 390)
@@ -17,10 +17,3 @@
 }
 
-#ifndef __c2__
 weak_alias(__gmtime_r, gmtime_r);
-#else
-struct tm *gmtime_r(const time_t *restrict t, struct tm *restrict tm)
-{
-	return __gmtime_r(t, tm);
-}
-#endif
Index: /azure_iot_hub/trunk/musl-1.1.18/src/time/localtime_r.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/time/localtime_r.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/time/localtime_r.c	(revision 390)
@@ -19,10 +19,3 @@
 }
 
-#ifndef __c2__
 weak_alias(__localtime_r, localtime_r);
-#else
-struct tm *localtime_r(const time_t *restrict t, struct tm *restrict tm)
-{
-	return __localtime_r(t, tm);
-}
-#endif
Index: /azure_iot_hub/trunk/musl-1.1.18/src/time/timer_create.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/time/timer_create.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/time/timer_create.c	(revision 390)
@@ -15,12 +15,8 @@
 };
 
-#ifndef __c2__
 static void dummy_1(pthread_t self)
 {
 }
 weak_alias(dummy_1, __pthread_tsd_run_dtors);
-#else
-extern void __pthread_tsd_run_dtors(pthread_t self);
-#endif
 
 void __reset_tls();
Index: /azure_iot_hub/trunk/musl-1.1.18/src/unistd/close.c
===================================================================
--- /azure_iot_hub/trunk/musl-1.1.18/src/unistd/close.c	(revision 389)
+++ /azure_iot_hub/trunk/musl-1.1.18/src/unistd/close.c	(revision 390)
@@ -4,5 +4,4 @@
 #include "libc.h"
 
-#ifndef __c2__
 static int dummy(int fd)
 {
@@ -11,7 +10,4 @@
 
 weak_alias(dummy, __aio_close);
-#else
-extern int __aio_close(int fd);
-#endif
 
 int close(int fd)